#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>

#define SESSION_FOLDER "/var/run/cwebfiles/sessions/"
#define SESSION_LENGTH 60 * 60 * 3 /* unit is seconds; we allow three-hour-sessions */

#define COOKIE_NAME "WEBFILESESS"
#define COOKIE_LENGTH 64

#define RANDDEV "/dev/urandom"

#define MYFAULT true
#define NOTMYFAULT false

struct cgi_serialized_session_status {
  // "man useradd" says 32 chars is the length limit
  char user_name[33];
  uid_t uid;
  time_t start_time;
};

extern struct cgi_serialized_session_status session;

void unhex(unsigned char *out, char *in, size_t in_len);
void hex(char *out, unsigned char *in, size_t in_len);
bool checkhex(char *p, size_t l);

int authenticate_by_cookie(char *cookie);
void persist_session(char *cookie);
void senderr(char *errmsg, bool myfault);
void grabrand(unsigned char *out, size_t len);
void login_and_setup();

#define OUTBUFSIZE 64*1024
#define FASTOUTPUT                             \
  char outbuf[OUTBUFSIZE];                     \
  setvbuf(stdout, outbuf, _IOFBF, OUTBUFSIZE); \

